import type { MetadataEventModel, ProcessId, ProcessModel, ThreadId, ThreadModel } from '../types';
import Bounds from '../util/bounds';
import type { CompleteEventModelImpl, EventModelImplUnion } from './event-model-impl';
export default class ThreadBuilder {
    pid: ProcessId;
    tid: ThreadId;
    bounds: Bounds | undefined;
    name: string;
    sortIndex: number;
    events: EventModelImplUnion[];
    stack: CompleteEventModelImpl[];
    constructor(pid: ProcessId, tid: ThreadId);
    get start(): number;
    get end(): number;
    addMetadata(event: MetadataEventModel): void;
    extendBounds(event: EventModelImplUnion): void;
    addEvent(event: EventModelImplUnion): void;
    build(process: ProcessModel): ThreadModel;
}
//# sourceMappingURL=thread-builder.d.ts.map