"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class Cache {
    constructor(create) {
        this.cache = new Map();
        this.create = create;
    }
    [Symbol.iterator]() {
        return this.cache.values();
    }
    get(key) {
        const { create, cache } = this;
        let item = cache.get(key);
        if (item === undefined) {
            item = create(key);
            cache.set(key, item);
        }
        return item;
    }
    values() {
        return this.cache.values();
    }
}
exports.default = Cache;
//# sourceMappingURL=cache.js.map